Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Parameters_msg_error.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Parameters_msg_error.cpp	(revision 68)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Parameters_msg_error.cpp	(revision 75)
@@ -9,6 +9,4 @@
 #include "Behavioural/Generic/Queue/include/Parameters.h"
 #include <sstream>
-using namespace std;
-
 namespace morpheo                    {
 namespace behavioural {
@@ -19,9 +17,9 @@
 #undef  FUNCTION
 #define FUNCTION "Queue::msg_error"
-  string Parameters::msg_error(void)
+  std::string Parameters::msg_error(void)
   {
     log_printf(FUNC,Queue,FUNCTION,"Begin");
 
-    string msg = "";
+    std::string msg = "";
 
     return msg;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Parameters_print.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Parameters_print.cpp	(revision 68)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Parameters_print.cpp	(revision 75)
@@ -8,5 +8,4 @@
 #include "Behavioural/Generic/Queue/include/Parameters.h"
 #include "Behavioural/include/XML.h"
-using namespace std;
 
 namespace morpheo                    {
@@ -18,5 +17,5 @@
 #undef  FUNCTION
 #define FUNCTION "Queue::print"
-  string Parameters::print (uint32_t depth)
+  std::string Parameters::print (uint32_t depth)
   {
     log_printf(FUNC,Queue,FUNCTION,"Begin");
@@ -36,6 +35,6 @@
 #undef  FUNCTION
 #define FUNCTION "Queue::operator<<"
-  ostream& operator<< (ostream& output_stream ,
-		       morpheo::behavioural::generic::queue::Parameters & x)
+  std::ostream& operator<< (std::ostream& output_stream ,
+			    morpheo::behavioural::generic::queue::Parameters & x)
   {
     log_printf(FUNC,Queue,FUNCTION,"Begin");
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Queue.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Queue.cpp	(revision 68)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Queue.cpp	(revision 75)
@@ -32,7 +32,4 @@
     ,_param            (param)
     ,_usage            (usage)
-// #ifdef STATISTICS
-// 			      ,_param_statistics (param_statistics)
-// #endif
   {
     log_printf(FUNC,Queue,FUNCTION,"Begin");
@@ -46,8 +43,5 @@
 	log_printf(INFO,Queue,FUNCTION,"Allocation of statistics");
 	
-	// Allocation of statistics
-	_stat = new Statistics (static_cast<string>(_name),
-				param_statistics          ,
-				param);
+	statistics_declaration(param_statistics);
       }
 #endif
@@ -102,5 +96,4 @@
 	log_printf(INFO,Queue,FUNCTION,"Generate Statistics file");
 	
-	_stat->generate_file(statistics(0));
 	delete _stat;
       }
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Queue_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Queue_allocation.cpp	(revision 68)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Queue_allocation.cpp	(revision 75)
@@ -19,6 +19,4 @@
   void Queue::allocation (void)
   {
-    string rename;
-
     log_printf(FUNC,Queue,FUNCTION,"Begin");
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Queue_end_cycle.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Queue_end_cycle.cpp	(revision 75)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Queue_end_cycle.cpp	(revision 75)
@@ -0,0 +1,40 @@
+#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Generic/Queue/include/Queue.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace generic {
+namespace queue {
+
+#undef  FUNCTION
+#define FUNCTION "Queue::end_cycle"
+  void Queue::end_cycle ()
+  {
+    log_printf(FUNC,Queue,FUNCTION,"Begin");
+
+#ifdef STATISTICS
+    _stat->end_cycle();
+#endif    
+
+#ifdef VHDL_TESTBENCH
+    // Evaluation before read the ouput signal
+//  sc_start(0);
+    _interfaces->testbench();
+#endif
+
+    log_printf(FUNC,Queue,FUNCTION,"End");
+  };
+
+}; // end namespace queue
+}; // end namespace generic
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Queue_statistics.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Queue_statistics.cpp	(revision 68)
+++ 	(revision )
@@ -1,35 +1,0 @@
-#ifdef STATISTICS
-/*
- * $Id$
- *
- * [ Description ]
- * 
- */
-
-#include "Behavioural/Generic/Queue/include/Queue.h"
-
-namespace morpheo {
-namespace behavioural {
-namespace generic {
-namespace queue {
-
-
-#undef  FUNCTION
-#define FUNCTION "Queue::statistics"
-  string Queue::statistics (uint32_t depth)
-  {
-    log_printf(FUNC,Queue,FUNCTION,"Begin");
-
-    string txt = _stat->print(depth);
-    
-    log_printf(FUNC,Queue,FUNCTION,"End");
-
-    return txt;
-  };
-
-}; // end namespace queue
-}; // end namespace generic
-
-}; // end namespace behavioural
-}; // end namespace morpheo              
-#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Queue_statistics_declaration.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Queue_statistics_declaration.cpp	(revision 75)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Queue_statistics_declaration.cpp	(revision 75)
@@ -0,0 +1,34 @@
+#ifdef STATISTICS
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Generic/Queue/include/Queue.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace generic {
+namespace queue {
+
+#undef  FUNCTION
+#define FUNCTION "Queue::statistics_declaration"
+  void Queue::statistics_declaration (morpheo::behavioural::Parameters_Statistics * param_statistics)
+  {
+    log_printf(FUNC,Queue,FUNCTION,"Begin");
+
+    _stat = new Stat (static_cast<std::string>(_name),
+                      "Queue",
+                      param_statistics);
+    
+    log_printf(FUNC,Queue,FUNCTION,"End");
+  };
+
+}; // end namespace queue
+}; // end namespace generic
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Queue_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Queue_transition.cpp	(revision 68)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Queue_transition.cpp	(revision 75)
@@ -53,10 +53,6 @@
       }
 
-#ifdef STATISTICS
-    _stat->add();
-#endif    
-
-#ifdef VHDL_TESTBENCH
-    vhdl_testbench_transition ();
+#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
+    end_cycle ();
 #endif
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Queue_vhdl_testbench_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Queue_vhdl_testbench_transition.cpp	(revision 68)
+++ 	(revision )
@@ -1,36 +1,0 @@
-#ifdef VHDL_TESTBENCH
-/*
- * $Id$
- *
- * [ Description ]
- * 
- */
-
-#include "Behavioural/Generic/Queue/include/Queue.h"
-
-namespace morpheo                    {
-namespace behavioural {
-namespace generic {
-namespace queue {
-
-
-#undef  FUNCTION
-#define FUNCTION "Queue::vhdl_testbench_transition"
-  void Queue::vhdl_testbench_transition ()
-  {
-    log_printf(FUNC,Queue,FUNCTION,"Begin");
-
-    // Evaluation before read the ouput signal
-//     sc_start(0);
-
-    _interfaces->testbench();
-
-    log_printf(FUNC,Queue,FUNCTION,"End");
-  };
-
-}; // end namespace queue
-}; // end namespace generic
-
-}; // end namespace behavioural
-}; // end namespace morpheo              
-#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Statistics.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Statistics.cpp	(revision 68)
+++ 	(revision )
@@ -1,44 +1,0 @@
-#ifdef STATISTICS
-/*
- * $Id$
- *
- * [ Description ]
- * 
- */
-
-#include "Behavioural/Generic/Queue/include/Statistics.h"
-
-namespace morpheo                    {
-namespace behavioural {
-namespace generic {
-namespace queue {
-
-
-#undef  FUNCTION
-#define FUNCTION "Queue::Statistics"
-  Statistics::Statistics (string                                        name                       ,
-			  morpheo::behavioural::Parameters_Statistics * parameters_statistics      ,
-			  Parameters                                  * parameters
-			  ) :
-    morpheo::behavioural::Statistics(name                  ,
-				     parameters_statistics ),
-    _parameters(parameters)
-  {
-    log_printf(FUNC,Queue,FUNCTION,"Begin");
-    log_printf(FUNC,Queue,FUNCTION,"End");
-  };
-  
-#undef  FUNCTION
-#define FUNCTION "Queue::~Statistics"
-  Statistics::~Statistics () 
-  { 
-    log_printf(FUNC,Queue,FUNCTION,"Begin");
-    log_printf(FUNC,Queue,FUNCTION,"End");
-  };
-
-}; // end namespace queue
-}; // end namespace generic
-
-}; // end namespace behavioural
-}; // end namespace morpheo              
-#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Statistics_add.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Statistics_add.cpp	(revision 68)
+++ 	(revision )
@@ -1,33 +1,0 @@
-#ifdef STATISTICS
-/*
- * $Id$
- *
- * [ Description ]
- * 
- */
-
-#include "Behavioural/Generic/Queue/include/Statistics.h"
-
-#include <sstream>
-using namespace std;
-
-namespace morpheo                    {
-namespace behavioural {
-namespace generic {
-namespace queue {
-
-
-#undef  FUNCTION
-#define FUNCTION "Queue::add"
-  void Statistics::add ()
-  {
-    log_printf(FUNC,Queue,FUNCTION,"Begin");
-    log_printf(FUNC,Queue,FUNCTION,"End");
-  };
-
-}; // end namespace queue
-}; // end namespace generic
-
-}; // end namespace behavioural
-}; // end namespace morpheo              
-#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Statistics_print.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Statistics_print.cpp	(revision 68)
+++ 	(revision )
@@ -1,57 +1,0 @@
-#ifdef STATISTICS
-/*
- * $Id$
- *
- * [ Description ]
- * 
- */
-
-#include "Behavioural/Generic/Queue/include/Statistics.h"
-
-#include <sstream>
-using namespace std;
-
-namespace morpheo {
-namespace behavioural {
-namespace generic {
-namespace queue {
-
-
-#undef  FUNCTION
-#define FUNCTION "Queue::print"
-  string Statistics::print (uint32_t depth)
-  {
-    log_printf(FUNC,Queue,FUNCTION,"Begin");
-
-    string        tab = string(depth,'\t');
-    ostringstream msg;
-
-    msg << tab << "<queue name=\"" << _name << "\" >" << endl
-        << print_body(depth+1) << endl
-	<< tab << "</queue>" << endl;
-    
-    log_printf(FUNC,Queue,FUNCTION,"End");
-
-    return msg.str();
-  };
-
-#undef  FUNCTION
-#define FUNCTION "Queue::operator<<"
-  ostream& operator<< (ostream& output_stream ,
-		       morpheo::behavioural::generic::queue::Statistics & x)
-  {
-    log_printf(FUNC,Queue,FUNCTION,"Begin");
-
-    output_stream << x.print(0);
-
-    log_printf(FUNC,Queue,FUNCTION,"End");
-
-    return output_stream;
-  };
-
-}; // end namespace queue
-}; // end namespace generic
-
-}; // end namespace behavioural
-}; // end namespace morpheo              
-#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Statistics_print_body.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Queue/src/Statistics_print_body.cpp	(revision 68)
+++ 	(revision )
@@ -1,41 +1,0 @@
-#ifdef STATISTICS
-/*
- * $Id$
- *
- * [ Description ]
- * 
- */
-
-#include "Behavioural/Generic/Queue/include/Statistics.h"
-
-#include <sstream>
-using namespace std;
-
-namespace morpheo                    {
-namespace behavioural {
-namespace generic {
-namespace queue {
-
-
-#undef  FUNCTION
-#define FUNCTION "Queue::print_body"
-  string Statistics::print_body (uint32_t depth)
-  {
-    log_printf(FUNC,Queue,FUNCTION,"Begin");
-
-    string        tab = string(depth,'\t');
-    ostringstream msg;
-
-    msg << tab << "";
-    
-    log_printf(FUNC,Queue,FUNCTION,"End");
-
-    return msg.str();
-  };
-
-}; // end namespace queue
-}; // end namespace generic
-
-}; // end namespace behavioural
-}; // end namespace morpheo              
-#endif
